﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.8
@EndOfDesignText@
'
Sub Class_Globals
#if B4A
	Private manager As BleManager2
#else if B4I
	Private manager As BleManager
#end if
	Private bc As ByteConverter
	Private HEART_RATE_SERVICE As String = "180d"
	Private HEART_RATE_MEASUREMENT As String = "2a37"
	Private firstRead As Boolean
End Sub

Public Sub Initialize
	HEART_RATE_SERVICE = UUID(HEART_RATE_SERVICE)
	HEART_RATE_MEASUREMENT = UUID(HEART_RATE_MEASUREMENT)
	manager.Initialize("manager")
End Sub

Private Sub Manager_StateChanged (State As Int)
	Log($"StateChanged: ${State}"$)
	If State = manager.STATE_POWERED_ON Then
		manager.Scan(Array(HEART_RATE_SERVICE))
	End If
End Sub


Private Sub Manager_DeviceFound (Name As String, DeviceId As String, AdvertisingData As Map, RSSI As Double)
	Log($"****************Name: ${Name}DeviceId: ${DeviceId}"$)
'Msgbox(Name,"Name")
ToastMessageShow(Name,False)
	manager.StopScan
	Log($"Connecting to: ${DeviceId}"$)
	manager.Connect(DeviceId)
End Sub

Private Sub Manager_Connected (Services As List)
	Log("Connected")
	firstRead = True
	manager.ReadData(HEART_RATE_SERVICE)
End Sub

Private Sub Manager_Disconnected
	Log("Disconnected")
End Sub


Private Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
	If firstRead Then
		firstRead = False
		manager.SetNotify(HEART_RATE_SERVICE, HEART_RATE_MEASUREMENT, True)
		Return
	End If
	
	Dim b() As Byte = Characteristics.Get(HEART_RATE_MEASUREMENT)
	Dim hrLength As Int = 1 + Bit.UnsignedShiftRight(b(0), 7)
	Dim rate As Int
	If hrLength = 1 Then
		rate = Bit.And(0xff, b(1))
	Else
		Dim r() As Byte = Array As Byte(b(1), b(2))
		rate = bc.IntsFromBytes(r)(0)
	End If
	Log($"HRM Rate: ${rate}"$)
	
	Tracker.hr = rate
	If IsPaused(Main) = False Then
		CallSubDelayed2(Main, "Heartbeat", rate)	'
	End If
	
	
End Sub

Private Sub UUID(id As String) As String
#if B4A
	Return "0000" & id.ToLowerCase & "-0000-1000-8000-00805f9b34fb"
#else if B4I
	Return id.ToUpperCase
#End If
End Sub